<?php
/**
 * Klutz base inclusion file.
 *
 * $Horde: klutz/lib/base.php,v 1.44 2008/01/07 15:37:17 mrubinsk Exp $
 *
 * This file brings in all of the dependencies that every Klutz
 * script will need and sets up objects that all scripts use.
 */

// Check for a prior definition of HORDE_BASE (perhaps by an
// auto_prepend_file definition for site customization).
if (!defined('HORDE_BASE')) {
    define('HORDE_BASE', dirname(__FILE__) . '/../..');
}

// Load the Horde Framework core, and set up inclusion paths.
require_once HORDE_BASE . '/lib/core.php';

// Registry.
if (Util::nonInputVar('session_control') == 'none') {
    $registry = &Registry::singleton(HORDE_SESSION_NONE);
} elseif (Util::nonInputVar('session_control') == 'readonly') {
    $registry = &Registry::singleton(HORDE_SESSION_READONLY);
} else {
    $registry = &Registry::singleton();
}
if (is_a(($pushed = $registry->pushApp('klutz', !defined('AUTH_HANDLER'))), 'PEAR_Error')) {
    if ($pushed->getCode() == 'permission_denied') {
        Horde::authenticationFailureRedirect();
    }
    Horde::fatal($pushed, __FILE__, __LINE__, false);
}
$conf = &$GLOBALS['conf'];
define('KLUTZ_TEMPLATES', $registry->get('templates'));

// Notification system.
$notification = &Notification::singleton();
$notification->attach('status');

// Find the base file path of Klutz.
if (!defined('KLUTZ_BASE')) {
    define('KLUTZ_BASE', dirname(__FILE__) . '/..');
}

// Klutz base libraries.
require_once KLUTZ_BASE . '/lib/Klutz.php';
require_once KLUTZ_BASE . '/lib/Comic.php';
require_once KLUTZ_BASE . '/lib/Image.php';
$GLOBALS['klutz'] = &new Klutz();

// Create a Klutz storage object.
require_once KLUTZ_BASE . '/lib/Driver.php';
$GLOBALS['storage'] = &Klutz_Driver::singleton();

// Get timezone data if available.
NLS::setTimeZone();

// Start compression.
if (Util::nonInputVar('compression_control') != 'none') {
    Horde::compressOutput();
}
