<?php
/**
 * Script for saving a comic to an image gallery. UI template stolen from
 * Imp's saveimage functionality.
 *
 * $Horde: klutz/savecomic.php,v 1.8 2008/11/14 17:55:37 mrubinsk Exp $
 *
 * Copyright 2005-2008 The Horde Project (http://www.horde.org/)
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author Michael Slusarz <slusarz@horde.org>
 * @author Michael Rubinsky <mrubinsk@horde.org>
 */

@define('KLUTZ_BASE', dirname(__FILE__));
require_once KLUTZ_BASE . '/lib/base.php';

$index = Util::getFormData('index');
$date = Util::getFormData('date');
$actionID = Util::getFormData('actionID');
$tags = Util::getFormData('tags');

/* We'll need the comic object to build the image name */
$comic = $klutz->comicObject($index);

switch ($actionID) {
case 'save_comic':
    /* Try to retrieve the image directly from storage first*/
    $image = $storage->retrieveImage($index, $date);
    if (is_string($image) && substr($image, 0, 4) == 'http') {
        $comic = $klutz->comicObject($index);
        $image = $comic->fetchImage($date);
    }
    if (!is_a($image, 'Klutz_Image')) {
        PEAR::raiseError(_("There was an error retrieving the comic."));
    } else {
        $desc = Util::getFormData('desc', '');
        $image_data = array(
            'filename' => $comic->name . '-' . strftime('%m%d%Y', $date) . '.' . str_replace('image/', '', $image->type), // Suggestions for better name?
            'description' => $desc,
            'data' => $image->data,
            'type' => $image->type,
            'tags' => explode(',', $tags)
        );
        $gallery = Util::getFormData('gallery');
        $res = $registry->call('images/saveImage',
                               array(null, $gallery, $image_data));
        if (is_a($res, 'PEAR_Error')) {
            $notification->push($res, 'horde.error');
            break;
        }
        Util::closeWindowJS();
    }
    exit;
}

/* Build the list of galleries. */
$id = $prefs->getValue('comicgallery');
$gallerylist = $registry->call('images/selectGalleries',
                                    array(null, PERMS_EDIT, null,
                                            true, 0, 0, $id));

$title = _("Save Image");
require KLUTZ_TEMPLATES . '/common-header.inc';
require KLUTZ_TEMPLATES . '/savecomic/savecomic.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
